package classicguns;


import net.minecraft.sounds.SoundEvent;
import net.minecraftforge.event.RegistryEvent;
import net.minecraft.resources.ResourceLocation;
/**
 * Registers this mod's {@link SoundEvent}s.
 *
 * @author Choonster
 */
public class CGSoundEvent {
    public static SoundEvent fire_rifle;
    public static SoundEvent fire_hg;
    public static SoundEvent fire_smg;
    public static SoundEvent fire_grenade;
    public static SoundEvent reload_mag;
    public static SoundEvent throw_grenade;

    /**
     * Register the {@link SoundEvent}s.
     */
    public static void registerSounds(RegistryEvent.Register<SoundEvent> event) {
        reload_mag = registerSound("classicguns.reload_mag");
        fire_rifle = registerSound("classicguns.fire_rifle");
        fire_hg = registerSound("classicguns.fire_hg");
        fire_smg = registerSound("classicguns.fire_smg");
        fire_grenade = registerSound("classicguns.fire_grenade");
        throw_grenade = registerSound("classicguns.throw_grenade");
    }


    public static SoundEvent getSound(String soundbase) {
        SoundEvent sound = fire_rifle;
        if(soundbase.equals("reload_mag")) {
            sound = reload_mag;
        }
        if(soundbase.equals("fire_rifle")) {
            sound = fire_rifle;
        }
        if(soundbase.equals("fire_hg")) {
            sound = fire_hg;
        }
        if(soundbase.equals("fire_smg")) {
            sound = fire_smg;
        }
        if(soundbase.equals("fire_grenade")) {
            sound = fire_grenade;
        }
        if(soundbase.equals("throw_grenade")) {
            sound = throw_grenade;
        }
        return sound;
    }

    /**
     * Register a {@link SoundEvent}.
     *
     * @param soundName The SoundEvent's name without the testmod3 prefix
     * @return The SoundEvent
     */
    private static SoundEvent registerSound(String soundName) {
        ResourceLocation soundID = new ResourceLocation(mod_ClassicGuns.MOD_ID, soundName);
        return new SoundEvent(soundID).setRegistryName(soundID);
    }


}