package classicguns;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.item.CreativeModeTab;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.Items;
import net.minecraft.world.level.block.Blocks;
import net.minecraftforge.client.event.EntityRenderersEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.event.lifecycle.FMLClientSetupEvent;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.loading.FMLLoader;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

@Mod(mod_ClassicGuns.MOD_ID)
public class mod_ClassicGuns {
    public static final String MOD_ID = "classicguns";

    private static final Logger LOGGER = LogManager.getLogger();

    public static Item item_bullet;
    public static  Item item_hg;
    public static  Item item_smg;
    public static  Item item_sr;
    public static  Item item_sg;
    public static  Item item_mg;
    public static  Item item_grenade;
    public static  Item item_gl;
    public static  Item item_flare;

    public static EntityType<EntityBullet> ENTITY_BULLET;
    public static EntityType<EntityGrenade> ENTITY_GRENADE;

    public mod_ClassicGuns() {
        IEventBus eventBus = FMLJavaModLoadingContext.get().getModEventBus();

        AddItems.register(eventBus);

        eventBus.addListener(this::setup);

        // Register ourselves for server and other game events we are interested in
        MinecraftForge.EVENT_BUS.register(this);

        if (FMLLoader.getDist().isClient()) {
            MinecraftForge.EVENT_BUS.register(new RenderGunEvent());
            MinecraftForge.EVENT_BUS.register(new RenderGunZoom());
        }
    }

    private void initClient(FMLClientSetupEvent event) {
       // RenderingRegistry.registerEntityRenderingHandler(ENTITY_BULLET, RenderBullet::new);
       // RenderingRegistry.registerEntityRenderingHandler(ENTITY_GRENADE, RenderGrenade::new);
    }

    // add a comment
    private void setup(final FMLCommonSetupEvent event) {
        // some preinit code
        LOGGER.info("HELLO FROM PREINIT");
        LOGGER.info("DIRT BLOCK >> {}", Blocks.DIRT.getRegistryName());
    }

    @Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
    public static class RegistryEvents {

        @SubscribeEvent
        public static void onItemsRegistry(RegistryEvent.Register<Item> event) {
            {
                item_bullet =  new Item(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_bullet"));
                event.getRegistry().register(item_bullet);
            }
            {
                item_grenade =  new ItemGrenade(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).stacksTo(8))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_grenade"));
                event.getRegistry().register(item_grenade);
            }
            {
                item_hg =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(7))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_hg"));
                ItemGunBase gun = (ItemGunBase) item_hg;
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_hg.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_hg.png";
                }
                gun.powor = 5;
                gun.speed = 3F;
                gun.bure = 3F;
                gun.bureads = 1.0F;
                gun.recoil = 2.0F;
                gun.recoilads = 0.5F;
                gun.reloadtime = 40;
                gun.scopezoom = 1.0F;
                gun.cycle = 3;

                gun.magazine = item_bullet;
                gun.fire_sound = "fire_hg";

                gun.model_y = -1.5F;
                gun.Sprintrotationx = -60F;
                gun.Sprintrotationy = 00F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 0.0F;
                gun.model_y_ads = -1.23F;
                gun.model_z_ads = -1.5F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
                event.getRegistry().register(item_hg);
            }
            {
                item_smg =  new ItemGun_AR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(21))
                        .setRegistryName(new ResourceLocation(mod_ClassicGuns.MOD_ID,"item_smg"));
                ItemGunBase gun = (ItemGunBase)item_smg;
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_smg.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_smg.png";
                }
                gun.powor = 5;
                gun.speed = 3F;
                gun.bure = 3F;
                gun.bureads = 1.5F;
                gun.recoil = 0.5F;
                gun.recoilads = 0.3F;
                gun.reloadtime = 60;
                gun.scopezoom = 1.0F;
                gun.cycle = 3;

                 gun.magazine = item_bullet;
                gun.fire_sound = "fire_smg";

                gun.model_y = -1.5F;
                gun.Sprintrotationx = 20F;
                gun.Sprintrotationy = 60F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 0.0F;
                gun.model_y_ads = -1.125F;
                gun.model_z_ads = -3F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
                event.getRegistry().register(item_smg);
            }
            {
                item_sr =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_sr"));
                ItemGunBase gun = (ItemGunBase) item_sr;
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_sr.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_sr.png";
                }
                gun.powor = 16;
                gun.speed = 16F;
                gun.bure = 2F;
                gun.bureads = 0.1F;
                gun.recoil = 2.0F;
                gun.recoilads = 1.0F;
                gun.reloadtime = 80;
                gun.scopezoom = 4.0F;
                gun.zoomrender = false;
                gun.cycle = 3;

                gun.magazine = item_bullet;
                gun.fire_sound = "fire_rifle";

                gun.model_y = -2F;
                gun.Sprintrotationx = 20F;
                gun.Sprintrotationy = 60F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 0.0F;
                gun.model_y_ads = -1.125F;
                gun.model_z_ads = -3F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
                event.getRegistry().register(item_sr);
            }
            {
                item_sg =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(4))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_sg"));
                ItemGunBase gun = (ItemGunBase) item_sg;
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_sg.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_sg.png";
                }
                gun.powor = 3;
                gun.speed = 2F;
                gun.bure = 8F;
                gun.bureads = 6F;
                gun.recoil = 4.0F;
                gun.recoilads = 3.0F;
                gun.reloadtime = 80;
                gun.pellet = 8;
                gun.scopezoom = 1.0F;
                gun.cycle = 3;

                gun.magazine = item_bullet;
                gun.fire_sound = "fire_rifle";

                gun.model_y = -1.5F;
                gun.Sprintrotationx = 20F;
                gun.Sprintrotationy = 60F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 0.0F;
                gun.model_y_ads = -0.92F;
                gun.model_z_ads = -1F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
                event.getRegistry().register(item_sg);
            }
            {
                item_mg =  new ItemGun_AR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(48))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_mg"));
                ItemGunBase gun = (ItemGunBase) item_mg;
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_mg.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_mg.png";
                }
                gun.powor = 5;
                gun.speed = 3F;
                gun.bure = 4F;
                gun.bureads = 2F;
                gun.recoil = 0.2F;
                gun.recoilads = 0.1F;
                gun.reloadtime = 100;
                gun.scopezoom = 1.0F;
                gun.cycle = 3;
                gun.movespeed = 0.5F;

                gun.magazine = item_bullet;
                gun.fire_sound = "fire_rifle";

                gun.model_y = -2F;
                gun.Sprintrotationx = 20F;
                gun.Sprintrotationy = 60F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 0.0F;
                gun.model_y_ads = -1.6F;
                gun.model_z_ads = -1.5F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
                event.getRegistry().register(item_mg);
            }
            {
                item_gl =  new ItemGun_SR(new Item.Properties().durability(2).tab(CreativeModeTab.TAB_COMBAT))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_gl"));
                ItemGunBase gun = (ItemGunBase) item_gl;
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_gl.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_gl.png";
                }
                gun.powor = 0;
                gun.speed = 2F;
                gun.bure = 3F;
                gun.bureads = 1.5F;
                gun.recoil = 5.0F;
                gun.recoilads = 2.5F;
                gun.reloadtime = 80;
                gun.scopezoom = 1.0F;
                gun.cycle = 3;

                gun.gra = 0.010F;
                gun.exlevel = 3.0F;
                gun.magazine = item_grenade;
                gun.fire_sound = "fire_grenade";

                gun.model_y = -2F;
                gun.Sprintrotationx = 20F;
                gun.Sprintrotationy = 60F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 0.0F;
                gun.model_y_ads = -1.8F;
                gun.model_z_ads = 1F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
                gun.mat22_x = 0.0F;
                gun.mat22_y = 0.6F;
                gun.mat22_z = 2.8F;
                event.getRegistry().register(item_gl);
            }
            {
                item_flare =  new ItemGun_SR(new Item.Properties().tab(CreativeModeTab.TAB_COMBAT).durability(2))
                        .setRegistryName(new ResourceLocation(MOD_ID,"item_flare"));
                ItemGunBase gun = (ItemGunBase) item_flare;
                if (FMLLoader.getDist().isClient())
                {
                    gun.obj_true = true;
                    gun.obj_model_resource = "classicguns:textures/model/model_flare.mqo";
                    gun.obj_tex = "classicguns:textures/model/model_flare.png";
                }
                gun.powor = -1;
                gun.speed = 2F;
                gun.bure = 0F;
                gun.bureads = 1.0F;
                gun.recoil = 2.0F;
                gun.recoilads = 0.5F;
                gun.reloadtime = 40;
                gun.scopezoom = 1.0F;
                gun.cycle = 3;

                gun.magazine = Items.TORCH;
                gun.gra = 0.02F;
                gun.fire_sound = "fire_grenade";

                gun.model_y = -1.5F;
                gun.Sprintrotationx = -60F;
                gun.Sprintrotationy = 00F;
                gun.Sprintrotationz = 0F;
                gun.model_x_ads = 1.8F;
                gun.model_y_ads = -2F;
                gun.model_z_ads = -3.5F;
                gun.model_muzz_jump_x = -5;
                gun.model_cock_z = -0.4F;
                gun.mat22_x = 0.0F;
                gun.mat22_y = 0.7F;
                gun.mat22_z = 1.2F;
                event.getRegistry().register(item_flare);
            }
        }

        @SubscribeEvent
        public static void registerSoundEvents(RegistryEvent.Register<SoundEvent> event) {
            CGSoundEvent.registerSounds(event);
        }

        @SubscribeEvent
        public static void registerEntityTypes(RegistryEvent.Register<EntityType<?>> event) {




            ENTITY_BULLET = EntityType.Builder.<EntityBullet>of(EntityBullet::new, MobCategory.MISC)
                    .setCustomClientFactory(EntityBullet::new)
                    .sized(0.15F, 0.15F)
                    .setShouldReceiveVelocityUpdates(false)
                    .setTrackingRange(60)
                    .setUpdateInterval(60)
                    .build("classicguns:entitybullet");
            ENTITY_BULLET.setRegistryName(new ResourceLocation("classicguns", "entitybullet"));
            //event.getRegistry().register(ENTITY_BULLET);


            ENTITY_GRENADE = EntityType.Builder.<EntityGrenade>of(EntityGrenade::new,MobCategory.MISC)
                    .setCustomClientFactory(EntityGrenade::new)
                    .sized(0.15F, 0.15F)
                    .setShouldReceiveVelocityUpdates(false)
                    .setTrackingRange(61)
                    .setUpdateInterval(61)
                    .build("classicguns:entitygrenade");
            ENTITY_GRENADE.setRegistryName(new ResourceLocation("classicguns", "entitygrenade"));
            // event.getRegistry().register(ENTITY_GRENADE);

            event.getRegistry().registerAll(ENTITY_BULLET, ENTITY_GRENADE);//event.getRegistry().registerAll(ENTITY_BULLET, ENTITY_GRENADE);
        }

        @SubscribeEvent
        public static void onRegisterRenderer(EntityRenderersEvent.RegisterRenderers event) {
            event.registerEntityRenderer(ENTITY_BULLET, RenderBullet::new);
            event.registerEntityRenderer(ENTITY_GRENADE, RenderGrenade::new);
        }
    }
}